var CompareShips = new Array ();

//*********************************************************************************************

function DelPost ()
{
	document.SelectObjects.ResetAll.value = "true";
	document.SelectObjects.submit ();
}

function LoadFileCheck ()
{
	var File1 = document.LoadFile.ShipData.value;
	var Reg1 = /[A-Za-z0-9_-]+\.c/;
	var File2 = document.LoadFile.ShipNames.value;
	var Reg2 = /[A-Za-z0-9_-]+\.ini/;
	
	if (File1 == "")
		alert ("ERROR: No ships-file selected!");
	else if (File2 == "")
		alert ("ERROR: No names-file selected!");
	else if (document.LoadFile.FileDesc.value == "")
		alert ("ERROR: No description entered!");
	else if (Reg1.test (File1) == false)
		alert ("ERROR: Wrong filename/type for ships-file! ('alpha-numeric', '_' and '-' (.c) only!)");
	else if (Reg2.test (File2) == false)
		alert ("ERROR: Wrong filename/type for names-file! ('alpha-numeric', '_' and '-' (.ini) only!)");
	else
		document.LoadFile.submit ();
}

function DeleteObject ()
{
	if (confirm ('Do you really want delete the selected data file(s)?'))
	{
		document.SelectObjects.SelectObjectsChoice.value = "delete";
		document.SelectObjects.submit ();
	}
}

function DeleteObjectCheck ()
{
	if (document.SelectObjects.DelObjCheck.checked == true)
	{
		document.SelectObjects.DelObj.disabled = false;
		document.SelectObjects.DelObj.className = "button";
	}
	else
	{
		document.SelectObjects.DelObj.disabled = true;
		document.SelectObjects.DelObj.className = "buttondis";
	}
}

function DisplayObject (Sort1, Sort2)
{
	if (typeof Sort1 !== "undefined" && Sort1 != "")
	{
		if (Sort1.className == "" || Sort1.className == "Asc")
			document.SelectObjects.SortValue1.value = "-"+Sort1.getAttribute("name");
		else
			document.SelectObjects.SortValue1.value = "+"+Sort1.getAttribute("name");
	}

	if (typeof Sort2 !== "undefined" && Sort2 != "")
	{
		if (Sort2.className == "" || Sort2.className == "Asc")
			document.SelectObjects.SortValue2.value = "-"+Sort2.getAttribute("name");
		else
			document.SelectObjects.SortValue2.value = "+"+Sort2.getAttribute("name");
	}
	
	document.SelectObjects.SelectObjectsChoice.value = "display";

	if (document.getElementById("ShowCanEncounter").checked)
		document.getElementById('ShowCanEncounterHidden').disabled = true;
	
	if (document.getElementById("ShowCanBuy").checked)
		document.getElementById('ShowCanBuyHidden').disabled = true;
	
	document.SelectObjects.submit ();
}

function ExpandCollapse (textid)
{
	whichtext = document.getElementById (textid);

	if (whichtext.className == "textshow")
	{
		whichtext.className="texthide";
	}
	else
	{
		whichtext.className="textshow";
	}
}

function SwitchCompare (Row, File)
{
	var Color = "lightblue";
	var Data = "<td>"+File+"</td>"+Row.innerHTML;

	if (Row.style.background == Color)
	{
		// remove from compare
		Row.style.background = "";
		CompareShips.splice (CompareShips.indexOf (Data), 1);
		DelElement (Row.cells[0].innerHTML);
	}
	else
	{
		// add to compare
		Row.style.background = Color;
		CompareShips.push (Data);
		AddElement (Row.cells[0].innerHTML);
	}
}

function AddElement (ID)
{
	var Div = document.getElementById("Compare");
	var New = document.createElement("div");
	
	New.id = ID;
	New.innerHTML = ID;
	Div.appendChild(New);
	Div.style.top = (Div.offsetTop - (New.offsetHeight)/2)+"px";	// Compare-Div mittig halten
}

function DelElement (ID)
{
	var Old = document.getElementById(ID);
	
	Old.parentNode.style.top = (Old.parentNode.offsetTop + (Old.offsetHeight)/2)+"px";	// Compare-Div mittig halten
	Old.parentNode.removeChild(Old);
}

function ShowCompare ()
{
	if (CompareShips.length < 2)
		alert ("At least two ships need to be selected");
	else
	{
		var Table = document.getElementById("TableCompare");
		var Head = document.getElementById("Header");
		
		// add header
		Row = Table.insertRow (-1);
		Row.className = "header";
		var Cell = Row.insertCell(0);
		Cell.innerHTML = "File";
		for (i=0; i<Head.cells.length; i++)
		{
			Cell = Row.insertCell(-1);
			Cell.innerHTML = Head.cells[i].innerHTML;
		}
		
		// add rows
		for (i=0; i<CompareShips.length; i++)
		{
			Row = Table.insertRow (-1);
			Row.className = "highlight";
			Row.innerHTML = CompareShips[i];
		}
		
		document.getElementById("DivCompare").style.display = "initial";
		document.getElementById("DivCompare").parentElement.style.overflow="hidden";
	}
}

function HideCompare ()
{
	document.getElementById("DivCompare").style.display = "none";
	document.getElementById("DivCompare").parentElement.style.overflow="initial";
	
	var Table = document.getElementById("TableCompare");
	var NumRows = Table.rows.length;
	
	// clear table
	for (i=0; i<NumRows; i++)
		Table.deleteRow(-1);
}

function SaveCompare ()
{
	var Table = document.getElementById("TableCompare");
	var Search = "";
	
	for (i=1; i<Table.rows.length; i++)
	{
		if (i>1)
			Search += "&";
		Search += "F[]="+Table.rows[i].cells[0].innerHTML+"&S[]="+Table.rows[i].cells[1].innerHTML;	// F ... Files | S ... Ships
	}
	
	var URL =  window.location.protocol+"//"+window.location.host+window.location.pathname+"?"+Search;
	prompt ("Copy this link and paste in address bar to compare these ships again!", URL);
}

function AskToSort ()
{
	var Sort = true;
	var Answ = confirm ("You entered a saved comparison: do you want the list to be sorted alphabetically?\n(click >>cancel<< to display it the way you added the ships)");
	
	if (Answ == false)
		Sort = false;
	
	window.location.assign (window.location.href+"&Sort="+Sort);
}