<?php
function DeletePost ()
{
	echo ('<form name="DelPost" action="index.php" method="POST">');
	echo ('<input type="hidden" name="DelPost" value="delpost">');
	echo ('</form>');
	echo ('<script type="text/javascript">document.DelPost.submit();</script>');
}


function ReturnClass ($MaxCrew)
{
	global $CrewToClass;
	
	for ($i=0; $i<sizeof($CrewToClass); $i++)
	{
		if ($MaxCrew >= $CrewToClass[$i])
			return ($i+1);
	}
	return (8);
}


function ImportData ()
{
	global $Include;
	global $Exclude;
	global $CrewToClassText;

	$File1Valid1 = false;
	$File1Valid2 = false;
	$File2Valid1 = false;
	$File2Valid2 = false;
	
	$Temp = "";
	$Value = array ();
	$Shipname = "";
	$Desc = $_POST["FileDesc"];
	$Data = array ();
	
	$CrewToClassVar = false;

	// Datei öffnen
	if (!$fp = fopen ($_FILES["ShipData"]["tmp_name"], "r"))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t read the file ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	else if (!$fp2 = fopen ($_FILES["ShipNames"]["tmp_name"], "r"))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t read the file ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	
	// Schiffs-Daten per Zeile einlesen
	for ($i=0; !feof ($fp); $i++)
	{
		$Temp = fgets ($fp);
		
		if (strpos ($Temp, "void InitShips") !== false)
			$File1Valid2 = true;
		
		if ($File1Valid2 === true && strpos ($Temp, "idx=0;idx<SHIP_TYPES_QUANTITY;idx++"))
			$File1Valid1 = true;
		
		if ($File1Valid1)
		{
			$Value = DecodeLine ($Temp);
			
			if ($Value == $CrewToClassText)
				$CrewToClassVar = true;

			// Value[1] = Type  (Name)
			// Value[2] = Value (Schooner)
			if ($Value !== false && substr ($Temp, 0, 2) != "//")	// Daten keine Bemerkung!
			{
				$Value[1] = strtolower ($Value[1]);
				
				if ($Value[1] == "name")
				{
					if (strpos_arr ($Value[2], $Exclude) === false)
					{
						// Schiffe mit gleichen Namen verschiedener Nationen werden derzeit einfach überschrieben!
						$Shipname = $Value[2];
						$Data[$Shipname] = array ();
					}
					else
						$Shipname = "";		// Datensatz und nächste Zeilen exkludieren!
				}
				else if ($Shipname != "" && in_array ($Value[1], array_keys ($Include)))
				{
					if (($Value[1] == "speedrate" || $Value[1] == "turnrate") && array_key_exists ($Value[1], $Data[$Shipname]))
					{
						// eg. SpeedRate -> 2 Werte für Realism und Normal!
						$Data[$Shipname][$Value[1]."realism"] = $Data[$Shipname][$Value[1]];
					}

					$Data[$Shipname][$Value[1]] = $Value[2];		// $Data["HorizonMod"]["Schooner"]["MaxCaliber"] = 12
				}
			}
		}
	}

	// Datei schließen
	fclose($fp);

	if ($File1Valid1)
	{
		// Schiffs-Namen per Zeile einlesen
		for ($i=0; !feof ($fp2); $i++)
		{
			$Temp = fgets ($fp2);
			
			if (trim ($Temp) == "; titles")
				$File2Valid2 = true;
			
			if ($File2Valid2 === true && trim ($Temp) == "; Ships")
				$File2Valid1 = true;
			
			if ($File2Valid1)
			{
				$Value = DecodeLine2 ($Temp);
				
				if ($Value !== false && substr ($Temp, 0, 1) != ";")	// Daten keine Bemerkung!
				{
					$Data2[$Value[1]] = $Value[2];			// $Data2["Warship1"] = "Fourth Rate Man 'o War"
				}
			}
		}
		
		fclose($fp2);

		if ($File2Valid1)
		{
			// Duplikate entfernen (Yacht1 / Yacht2), außer es gibt Unterschiede (siehe: Galeon1 / Galeon2)
			$TempName = "";
			$TempArr = array();
			ksort ($Data);
			foreach ($Data as $ShipName => $ShipData)
			{
				// Default-Werte setzen
				if ($CrewToClassVar)
					$Data[$ShipName]["class"] = ReturnClass ($Data[$ShipName]["maxcrew"]);

				if (!isset ($ShipData["canencounter"]))
					$Data[$ShipName]["canencounter"] = "true";
				
				if (!isset ($ShipData["canbuy"]))
					$Data[$ShipName]["canbuy"] = "true";
				
				// Statt SName den ingame-Namen einfügen
				if (isset ($ShipData["sname"]) && isset ($Data2[$ShipData["sname"]]))
					$Data[$ShipName]["sname"] = $Data2[$ShipData["sname"]];
				else if (isset ($Data2[$ShipName]))
					$Data[$ShipName]["sname"] = $Data2[$ShipName];
				else
				{
					print_r ($ShipData);
					exit ('<br>No SName or Real Name for '.$ShipName.' found!<br/>');
				}
				
				$Len = strlen($ShipName)-1;
				if ($TempName != "" && substr_compare ($ShipName, $TempName, 0, $Len, true) == 0)
				{
					if (!array_diff_assoc ($ShipData, $TempArr))
					{
						$NewName = substr ($ShipName, 0, $Len);
						$Data[$NewName] = $Data[$ShipName];
						unset ($Data[$ShipName]);
						unset ($Data[$TempName]);
					}
				}
				$TempName = $ShipName;
				$TempArr = $ShipData;
			}
			ksort ($Data);
			
			// Daten speichern
			SaveData ($Desc, $Data);
		}
		else
		{
			echo ('<script type="text/javascript">alert ("The uploaded names-file is not valid!");</script>');
			DeletePost ();
			exit (-1);
		}
	}
	else
	{
		echo ('<script type="text/javascript">alert ("The uploaded ships-file is not valid!");</script>');
		DeletePost ();
		exit (-1);
	}
}


function SaveData ($DataFile, $Data)
{
	global $DataDir;

	if (!$fp = fopen ($DataDir.'/'.$DataFile, 'w'))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t write to the file: ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	else
	{
		fwrite ($fp, serialize($Data));
		fclose ($fp);
		DeletePost ();
	}
}


function LoadData ($DataFile)
{
	global $DataDir;

	if (!$fp = fopen ($DataDir.'/'.$DataFile, "r"))
	{
		echo ('<script type="text/javascript">alert ("Couldn\'t read the file: ('.$fp.')!");</script>');
		DeletePost ();
		exit (-1);
	}
	else
	{
		$Data = unserialize (fgets ($fp));
		fclose ($fp);
		return ($Data);
	}
}


function DecodeLine ($String)
{
	global $CrewToClassText;
	
	if (stripos ($String, $CrewToClassText))		// is class based on the property or on MaxCrew?
		return ($CrewToClassText);
	
	// refShip.%type%		= %number%;						refShip.Class           = 7;
	// refShip.%type%		= %text%;						refShip.CanEncounter	= false;
	$Ret = preg_match ('/refShip\.([\w]*)[\s]*=[\s]*([\w]+[\.]?[\w]*);/i', $String, $Arr);				// Diverse

	// refShip.%name%		= "%text/number%";				refShip.Name            = "SP_CastelF";
	if ($Ret == 0)
		$Ret = preg_match ('/refShip\.(Name)[^;][^=]*=[^"]*"([\w]+)";/i', $String, $Arr);				// Name mit Nummer
	
	// refShip.%sname%		= "%text/number%";				refShip.SName            = "Brig1T";
	if ($Ret == 0)
		$Ret = preg_match ('/refShip\.(SName)[^;][^=]*=[^"]*"([\w]+)";/i', $String, $Arr);				// SName mit Nummer
	
	// refShip.%periode%	= %number%; //					refShip.period.0 = 0.8; //
	if ($Ret == 0)
		$Ret = preg_match ('/refShip\.(period.[0-9])[^=]*=[^\d]*([0-9]\.[0-9]);/i', $String, $Arr);		// Periode
	
	if ($Ret == 1)
		return ($Arr);
	else
		return (false);
}


function DecodeLine2 ($String)
{
	// string = %ID%, %Name%								string = Warship1,"Fourth Rate Man 'o War"
	$Ret = preg_match ('/string = ([\w]+),[\s]*"([^"]+)"/i', $String, $Arr);							// Namenzuordnung
	
	if ($Ret == 1)
		return ($Arr);
	else
		return (false);
}


function strpos_arr ($haystack, $needle)
{
	if (!is_array ($needle))
		$needle = array ($needle);
	
	foreach ($needle as $what)
	{
		if (($pos = strpos($haystack, $what))!==false)
			return $pos;
	}
	return false;
}


function SortDataBy ($Data, $Sort1, $Sort2="")
{
	$SortBy1 = SORT_ASC;
	$SortBy2 = SORT_ASC;
	
	if ($Sort1[0] == "-")
		$SortBy1 = SORT_DESC;		
	$Sort1 = substr ($Sort1, 1);
	
	if ($Sort2 != "")
	{
		if ($Sort2[0] == "-")
			$SortBy2 = SORT_DESC;
		$Sort2 = substr ($Sort2, 1);
	}

	foreach ($Data as $Key => $Value)
	{
		if ($Sort1 == "Name")
			$temp[$Key] = "";
		else
		{
			if (array_key_exists ($Sort1, $Value))
				$temp[$Key] = $Value[$Sort1];
			else
				$temp[$Key] = $Value[str_ireplace ("realism", "", $Sort1)];
		}
		
		if ($Sort2 != "")
		{
			if ($Sort2 == "Name")
				$temp2[$Key] = "";
			else
			{
				if (array_key_exists ($Sort2, $Value))
					$temp2[$Key] = $Value[$Sort2];
				else
					$temp2[$Key] = $Value[str_ireplace ("realism", "", $Sort2)];
			}
		}
	}

	if ($Sort2 == "")		// sort by "Sort1" and Name
	{
		if ($Sort1 == "Name")
			array_multisort (array_keys($temp), $SortBy1, $temp);
		else
			array_multisort (array_values($temp), $SortBy1, array_keys($temp), SORT_ASC, $temp);
	}
	else					// sort by "Sort1" and "Sort2" and Name
	{
		if ($Sort1 == "Name")
			array_multisort (array_keys($temp), $SortBy1, array_values($temp2), $SortBy2, $temp);
		else if ($Sort2 == "Name")
			array_multisort (array_values($temp), $SortBy1, array_keys($temp2), $SortBy2, $temp);
		else
			array_multisort (array_values($temp), $SortBy1, array_values($temp2), $SortBy2, array_keys($temp), SORT_ASC, $temp);
	}

	$Data = array_merge ($temp, $Data);
	
	return ($Data);
}


function MultiSortByKey ($Arr, $Key)
{
	$Temp = Array(); 
	foreach($Arr as &$Value) 
		$Temp[] = &$Value[$Key]; 
	array_multisort($Temp, $Arr);
	return ($Arr);
}


function ShowSavedCompare ($ShowArr)
{
	global $Include;
	$Sort = $ShowArr["Sort"];
	$FullData = array ();
	$DataFiles = array ();
	
	for ($i=0; $i<sizeof($ShowArr["F"]); $i++)
	{
		$FullData[$i]["File"] = $ShowArr["F"][$i];
		$FullData[$i]["Name"] = $ShowArr["S"][$i];
		$DataFiles[$ShowArr["F"][$i]] = "";
	}

	$DataFiles = array_keys ($DataFiles);
	
	if ($Sort == "true")
		$FullData = MultiSortByKey ($FullData, "Name");

	foreach ($DataFiles as $File)
	{
		$Data = LoadData ($File);
		
		for ($i=0; $i<sizeof($FullData); $i++)
		{
			// der erste Merge erzeugt ein Array mit allen gewünschten Datenfeldern und füllt die Zellen ohne Inhalt aus
			// der zweite Merge sorgt dafür, dass die vorhanden Daten des FullData nicht überschrieben werden
			if ($FullData[$i]["File"] == $File)
				$FullData[$i] = array_merge ($FullData[$i], array_merge (array_fill_keys (array_keys ($Include), '-'), $Data[$FullData[$i]["Name"]]));
		}
	}
	
	// Header
	echo ('<tr class="header">');
	foreach ($FullData[0] as $Type => $Data)
	{
		if (array_key_exists ($Type, $Include))
			echo ('<td>'.$Include[$Type].'</td>');
		else
			echo ('<td>'.$Type.'</td>');
	}
	echo ('</tr>');
	
	// Data
	for ($i=0; $i<sizeof($FullData); $i++)
	{
		echo ('<tr class="highlight"><td style="text-align:left;">'.$FullData[$i]["File"].'</td><th>'.$FullData[$i]["Name"].'</th>');
		$FullData[$i] = array_slice ($FullData[$i], 2);
		foreach ($FullData[$i] as $Type => $Data)
			echo ('<td onmouseover="Tip(\''.$Include[$Type].'\', DURATION, 1300, OPACITY, 100);" onmouseout="UnTip();">'.$Data.'</td>');
		echo ('</tr>');
	}

	// Show overlay
	echo ('<script>document.getElementById("DivCompare").style.display = "initial"; document.getElementById("DivCompare").parentElement.style.overflow="hidden";</script>');
}
?>
